using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace Kohonen
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button TrainBtn;
		private System.Windows.Forms.TextBox [,] wBox;
		private System.Windows.Forms.TextBox textBox1;
		private Network thenet;
		private System.Windows.Forms.Label WordLbl;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label VarLbl;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();	

			// Setting up boxs for neurons
			wBox = new TextBox[8,8];
			this.SuspendLayout();
			for (int i=0;i<8;i++)
				for (int j=0;j<8;j++)
				{
					wBox[i,j] = new System.Windows.Forms.TextBox();
					wBox[i,j].Location = new System.Drawing.Point(10+i*60,10+j*20);
					wBox[i,j].Text="";
					wBox[i,j].Size = new System.Drawing.Size(50,15);
					this.Controls.Add(wBox[i,j]);
				}
			this.ResumeLayout();
			

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.TrainBtn = new System.Windows.Forms.Button();
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.WordLbl = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.VarLbl = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// TrainBtn
			// 
			this.TrainBtn.Location = new System.Drawing.Point(32, 256);
			this.TrainBtn.Name = "TrainBtn";
			this.TrainBtn.TabIndex = 1;
			this.TrainBtn.Text = "Train";
			this.TrainBtn.Click += new System.EventHandler(this.TrainBtn_Click);
			// 
			// textBox1
			// 
			this.textBox1.BackColor = System.Drawing.SystemColors.Window;
			this.textBox1.Location = new System.Drawing.Point(168, 256);
			this.textBox1.Name = "textBox1";
			this.textBox1.TabIndex = 2;
			this.textBox1.Text = "";
			this.textBox1.TextChanged += new System.EventHandler(this.textBox1_TextChanged);
			// 
			// WordLbl
			// 
			this.WordLbl.Location = new System.Drawing.Point(360, 256);
			this.WordLbl.Name = "WordLbl";
			this.WordLbl.TabIndex = 3;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(296, 256);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(56, 24);
			this.label1.TabIndex = 5;
			this.label1.Text = "Word:";
			// 
			// VarLbl
			// 
			this.VarLbl.Location = new System.Drawing.Point(168, 280);
			this.VarLbl.Name = "VarLbl";
			this.VarLbl.TabIndex = 6;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(504, 317);
			this.Controls.Add(this.VarLbl);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.WordLbl);
			this.Controls.Add(this.textBox1);
			this.Controls.Add(this.TrainBtn);
			this.Name = "Form1";
			this.Text = "Kohonen";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
			
		}

		private void TrainBtn_Click(object sender, System.EventArgs e)
		{
			//Words used by network
			string [] nameset = new string[]
				{"hello","I","town","city","edition","myself","your","him","hers","hurts","help",
				"goal","touch","food","fuel","homerun","am","world","brain","neuron","ask","past","cast",
				"ice","goodbye"};

            //Convert to arrays of float																					
			float [][] trainingset = new float[25][];
			char [] dummy = new char [7];
			int i = 0;
			int j;
			foreach (string str in nameset)
			{
				j=0;
				trainingset[i] = new float[7];
				dummy = str.ToCharArray();
				while (j<dummy.Length)
				{
					trainingset[i][j] = (float)dummy[j];
					j++;
				}
				while (j<7) 
				{
					trainingset[i][j] = (float)' ';
					j++;
				}
				i++;
			}

			//Initialise network
			thenet = new Network(7,8,8);

			//Normalise trainingset
			i = 0;
			for (;i<25;i++)
			{
				thenet.Normalise(ref trainingset[i]);
			}

			//train network
			float Gain = (float)0.6;
			int Range = 10;
			int count = 1000;
			j = 0;
			while (count>0 || Range>0) 
			{  
				thenet.Train(trainingset[j],Range,Gain);
				if (j==24) j=0; else j++;
				if (count==0 && Range>0) 
				{
					count = 1000;
					Range--;
				} 
				else 
				{
					if (count==0) 
					{
						count=1000;
					}
					else count--;
				}
				if (Gain>0.05) Gain -= (float)0.05;
			}

			//Find word from nameset in network
			float val;
			for (int k=0;k<25;k++)
			{
				i = j = 8;
				val = thenet.GetWinner(ref i,ref j,trainingset[k]);
				int m=0;
				for (;m<7;m++)
				{
					if (m<nameset[k].Length)
						dummy[m] = nameset[k][m];
					else
						dummy[m] = ' ';
				}
				for (m=0;m<7;m++) 
					thenet.Net[i,j].Textname += System.Convert.ToString(dummy[m]);

				//Store the names and the scores within the neuron
				wBox[i,j].Text = thenet.Net[i,j].Textname;
				thenet.Net[i,j].Perfectval = val;
			}		
		}

		private void textBox1_TextChanged(object sender, System.EventArgs e)
		{
			//Find word in network
			int i = 0;
			int j = 0;			
			if (textBox1.Text != "")
			{
				//Convert text to float
				float [] check = new float[7];
				for (i=0;i<7;i++)
				{
					if (i<textBox1.Text.Length)
						check[i] = (float)textBox1.Text[i];
					else
						check[i] = (float)' ';
				}
				
				//Normalise
				thenet.Normalise(ref check);

				//Find neuron thatlights up
				float val = thenet.GetWinner(ref i,ref j,check);
				WordLbl.Text = thenet.Net[i,j].Textname;
				if (WordLbl.Text != "")
					val = (val/thenet.Net[i,j].Perfectval);

				//Check if it is known
				if (val == 1) 
					VarLbl.Text = "I know this word";
				else
					VarLbl.Text = "Unknown word";
			}
			else
			{
				VarLbl.Text = "";
				WordLbl.Text = "";
			}
		}

	}
}
