using System;

namespace Kohonen
{
	/// <summary>
	/// 
	/// </summary>
	public class Neuron
	{
		//Stores the weights of the neuron
		private float [] weights;
		public float [] Weights
		{
			get
			{
				return weights;
			}
			set
			{
				weights = value;
			}
		}

		//Stores the word it remembers
		private string textname;
		public string Textname
		{
			get
			{
				return textname;
			}
			set
			{
				textname = value;
			}
		}

		//Stores the value the remembered word creates
		private float perfectval;
		public float Perfectval
		{
			get
			{
				return perfectval;
			}
			set
			{
				perfectval = value;
			}
		}

		//Number of inputs to neuron
		private int inSize;
		public int InSize
		{
			get
			{
				return inSize;
			}
			set
			{
				inSize = value;
			}
		}

		//Constructor
		public Neuron(int size)
		{
			weights = new float[size];
			inSize = size;
			textname = "";
			perfectval = 0;
		}

		//Find the output of the neuron from inputs
		public float Inputs(float [] inputs)
		{
			float val = 0;
			for (int i=0; i<inSize; i++) 
			{
				val += (inputs[i]-weights[i])*(inputs[i]-weights[i]);
			}
			return val;
		}
	}
}
